%bcond_without check

%global goipath	github.com/maxmind/geoipupdate
Version:	6.0.0

%gometa

Name:		geoipupdate
Release:    1%{?dist}
Summary:	Update GeoIP2 binary databases from MaxMind

License:	Apache-2.0 OR MIT
URL:		http://dev.maxmind.com/geoip/geoipupdate/
Source0:	geoipupdate-%{version}.tar.gz
Source1:	geoipupdate.cron

BuildRequires:	coreutils
BuildRequires:	crontabs
BuildRequires:	golang(github.com/cenkalti/backoff/v4)
BuildRequires:	golang(github.com/gofrs/flock)
BuildRequires:	golang(github.com/spf13/pflag)
BuildRequires:	golang(golang.org/x/sync/errgroup)
BuildRequires:	make
BuildRequires:	go-rpm-macros
BuildRequires:	pandoc
BuildRequires:	perl-interpreter
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	sed

%if %{with check}
BuildRequires:	golang(github.com/stretchr/testify/assert)
BuildRequires:	golang(github.com/stretchr/testify/require)
%endif

%description
The GeoIP Update program performs automatic updates of GeoIP2 binary databases.

%package cron
Summary:	Cron job to do weekly updates of GeoIP databases
BuildArch:	noarch
Requires:	%{name} = %{version}-%{release}
Requires:	crontabs
Provides:	GeoIP-update = 1.6.0

%description cron
Cron job for weekly updates to GeoIP2 binary databases from MaxMind.

%prep
%goprep

%build
export LDFLAGS='-X main.defaultConfigFile=%{_sysconfdir}/GeoIP.conf -X main.defaultDatabaseDirectory=%{_datadir}/GeoIP '
%gobuild -o %{gobuilddir}/bin/geoipupdate %{goipath}/cmd/geoipupdate

ln -s %{gobuilddir} build

make BUILDDIR=%{gobuilddir} CONFFILE=%{_sysconfdir}/GeoIP.conf DATADIR=%{_datadir}/GeoIP data

%install
install -d %{buildroot}%{_bindir}
install -p -m 0755 %{gobuilddir}/bin/geoipupdate %{buildroot}%{_bindir}/geoipupdate

install -d %{buildroot}%{_sysconfdir}
install -p -m 0644 conf/GeoIP.conf.default %{buildroot}%{_sysconfdir}/GeoIP.conf

install -d %{buildroot}%{_datadir}/GeoIP

install -D -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/cron.weekly/geoipupdate

install -d %{buildroot}%{_mandir}/man1
install -p -m 0644 _build/geoipupdate.1 %{buildroot}%{_mandir}/man1/geoipupdate.1
install -d %{buildroot}%{_mandir}/man5
install -p -m 0644 _build/GeoIP.conf.5 %{buildroot}%{_mandir}/man5/GeoIP.conf.5

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE-APACHE LICENSE-MIT
%doc conf/GeoIP.conf.default README.md CHANGELOG.md
%doc doc/GeoIP.conf.md doc/geoipupdate.md
%config(noreplace) %{_sysconfdir}/GeoIP.conf
%{_bindir}/geoipupdate
%dir %{_datadir}/GeoIP/
%{_mandir}/man1/geoipupdate.1*
%{_mandir}/man5/GeoIP.conf.5*

%files cron
%config(noreplace) %{_sysconfdir}/cron.weekly/geoipupdate

%changelog
* Thu Sep 19 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.0.0-1
- initial build
